#!/usr/bin/perl

# au: vitas (vitas@matfyz.cz)
# cp: dcit s.r.o. (miko@dcit.cz)

#
# faze 1: zjisteni ip
# faze 2: konzistence dns
#
# dale se pracuje jen s jednou ip.
# f3: whois
# f4: nmap
# f5: whisker
# f6: nessus

%zzz;
$whois_is_gnu = 1;

use Socket;

(LOG_FILE);

($host_name, $host_ip);
$nmap_ports = "1-100"; # naostro bude: "-p1-"
$nmap_ports2 = "1-100";
@host_names;
@host_nservers;
@host_ips;
$hi_file = "hi-unknown";
$test_sth = 0;
%host_ports_tcp;
%host_ports_udp;

############################################################################
# war(id, desc)
# 
sub war() {
	my ($desc) = @_;;
	&htmllog_msg("$desc\n");
	$desc =~ s/<li>/\*/g;
	$desc =~ s/<[^>]*>//g;
	print("$desc\n");
} #war

sub warr() {
	my ($desc) = @_;;
	&htmllog_msg("$desc\n");
} #war

############################################################################
# ahref(href, txt) -- obali odkaz tagem <a>
#

sub ahref() {
	my ($href, $txt) = @_;;
	return "<a href=\"$href\">$txt</a>";
} # ahref

# system() s tim, ze loguje a kdyz se nepovede tak zdechne.
sub my_system() {
	my ($cmd, $tag) = @_;;

	&log_sec("\$ $cmd\n", $tag);

	open(F,  "$cmd|") or die "cannt exe \$ $cmd\n";
	while($r = <F>) {
		&log_msg($r)
	}
	close(F);
} # my_system

sub date(){
	open DATE, "date|";
	my $ret = <DATE>;
	close DATE;

	return $ret;
}

############################################################################
# log_msg
# log_cmd
# log_open,close
# 

($log_pre_opened, $log_name); 

sub log_open() {
	my ($logname) = @_;;
	$log_name = "$hi_file-$logname.html";
	open LOG_FILE, ">$log_name" or die "cannt write  $log_name";

	print LOG_FILE "<html>\n".
			"<head><title>$log_name -- host info</title></head>\n".
			"<body>\n\n";
	$log_pre_opened = 0;
}

sub log_close() {
	
	if( $log_pre_opened ) {
		print LOG_FILE "</pre>\n"; 
	}
	print LOG_FILE "\n</body></html>\n";
	close (LOG_FILE);
} # log_close

sub log_msg() {
	print LOG_FILE @_;;
} # log_msg

sub log_sec() {
	my ($secname, $tag) = @_;;
	if( $log_pre_opened ) {
		print LOG_FILE "</pre>\n"; 
	}
	chomp($secname);
	print LOG_FILE "<a name=\"$tag\"></a>\n" if($tag); 
	print LOG_FILE "\n<h2>\n$secname</h2>\n\n<pre>";
	$log_pre_opened = 1;
} # log_sec

#################################################################
#
# htmllog_{save,load,cls,msg}
#
(%htmllog); #hash stringu jednotlivych testu
($htmllog_sec); # aktualni sekce

sub htmllog_load() {
	my $filename = "$hi_file-main.html";;

	if( not -f "$filename" ) {
		print "! nemam  $filename\n";
		return;
	}

	open(HTMLLOG, $filename) or die "cannt open $filename";

	my $sec = "begin";

	while($r = <HTMLLOG> ) {

		chomp($r);
		if( $r =~ /^<!-- test: (\S*) -->$/ ) {
			$sec = $1;
			next;
		}
		$htmllog{"$sec"} .= "$r\n";
	}

	close(HTMLLOG);

} # htmllog_load

sub htmllog_save_old() {
	my $filename = "$hi_file-main.html";

	&htmllog_cls("begin",
"<html>
<head><title>hi -- $host_name ($host_ip)</title></head>
<body>\n");
	&htmllog_cls("end", "\n\n</body></html>\n");

	open(HTMLLOG, ">$filename") or die "cannt write to $filename";

	print HTMLLOG "$htmllog{begin}";

	for my $sec (qw(dns whois nmap whisker nessus history end)) {
		print HTMLLOG "<!-- test: $sec -->\n";
		print HTMLLOG "$htmllog{$sec}";
	}

	print HTMLLOG "<h2>Logy</h2>\n\n";

	for my $log (qw(dns whois nmap whisker nessus)) {
		my $fname = "$hi_file-$log.html";
		if(not -f $fname) {
			next;
		}
		open(FROM, $fname) or die "cann open $fname";
		while($r = <FROM>) {
			if( $r =~ /^<html>|
					^<head>|	
					^<body>|	
					^<\/body>|	
					^<\/html>/x ) {
				next;
			}
			print HTMLLOG $r;
		}
		close(FROM);
		
	}

	print HTMLLOG "<hr>Generated by hi.pl -- ".
		"<a href=\"http:/www.dcit.cz/\">Dcit s.r.o</a>".
		"</body></html>";
	close(HTMLLOG);
} # htmllog_save

sub zzz_print() {
	my $k;
	foreach$k(sort keys %zzz) {
		if($k =~ /table$/) {
			next;
		}

		my $p = $zzz{$k};
		$p =~ s/\n/\\n/g;
		print "$k:$p\n";
	}
} # zzz_print

sub zzz_prepare_nmap_table() {

	my %tcp = %host_ports_tcp;
	my %udp = %host_ports_udp;

	my @tbl;

	$zzz{'nmap-tcp-open-count'} = @{$tcp{'open'}};
	$zzz{'nmap-udp-open-count'} = @{$udp{'open'}};

	$tcp{"$tcp{'rest'}+"}[0] = "ostatn"; ###out
	$udp{"$udp{'rest'}+"}[0] = "ostatn"; ###out

	$tbl[0] = $tcp{'open+'};
	$tbl[1] = $tcp{'closed+'};
	$tbl[2] = $tcp{'filtered+'};

	$tbl[3] = $udp{'open+'};
	$tbl[4] = $udp{'closed+'};
	$tbl[5] = $udp{'filtered+'};

	my ($tbl_txt);
	
	while(1){
		$sum=0;
		my $line;
		foreach$i(0 .. 5){
			$sum += @{$tbl[$i]};
			my $it = shift(@{$tbl[$i]});
			$line .= "  <td>$it</td>\n" ###out
		}
		
		if(not $sum) {
			last;
		}
		$tbl_txt .= "<tr>\n$line</tr>\n\n"; ###out
	} 
	$zzz{'nmap-ports-table'} =$tbl_txt;


} # zzz_prepare_nmap_table


sub zzz_lines_as_tr() {
	my ($txt) = @_;;

	return
		"<tr><td>".
		join("  </td></tr>\n<tr><td>", split("\n", $txt) ).
		"</td></tr>";
}  # zzz_lines_as_tr


sub zzz_whisker_table() {

	if($was_whisker) {

		my $wn = $whisker_http{'note'};
		my $wr = $whisker_http{'report'};
		my $wc = 0 + split("\n", $wr);

		$zzz{'whisker-server'} = $whisker_http{'server'};
		$zzz{'whisker-report-count'} = $wc ." ";
		if(not $wc) {
			$wr = "dn nalezen nedostaky";
		}
		$zzz{'whisker-table'} = &zzz_lines_as_tr($wr);
	}

	if($was_whiskers) {

		my $wn = $whisker_https{'note'};
		my $wr = $whisker_https{'report'};
		my $wc = 0 + split("\n", $wr);

		$zzz{'whiskers-server'} = $whisker_https{'server'};
		$zzz{'whiskers-report-count'} = $wc . " ";

		if(not $wc) {
			$wr = "dn nalezen nedostaky";
		}
		$zzz{'whiskers-table'} = &zzz_lines_as_tr($wr);
	}

} # zzz_prepare_whisker_table

sub zzz_prepare() {

	$zzz{'host-name-or-ip'} = $host_name_or_ip;

	$zzz{'host-names'} = join "<br>" , @host_names;
	$zzz{'host-name'} = $host_name;
	$zzz{'host-ip'} = $host_ip;

	$zzz{'host-ip-owner'} = $host_ip_owner;

	$zzz{'dns-jmeno-or-jmena'} = @host_name ==
		1?"DNS jmno":"DNS jmna";
 
	$zzz{'second-level-domain'}  = $second_level_domain;
	$zzz{'second-level-domain-owner'} = $second_level_domain_owner;

	$zzz{'test-begin'} = $test_begin;
	$zzz{'test-end'} = $test_end;

	$zzz{'icmp-ping'} = $icmp_ping;


	$zzz{'host-os'} = $host_os;
	$zzz{'nmap-tcp-ports'} = $nmap_ports;
	$zzz{'nmap-udp-ports'} = $nmap_ports2;

	$zzz{'nmap-version'} = $nmap_version;
	$zzz{'nessus-version'} = $nessus_version;

	$zzz{'nessus-info-count'} = $nessus_info_count;
	$zzz{'nessus-note-count'} = $nessus_note_count;
	$zzz{'nessus-report-count'} = $nessus_report_count;

	&zzz_prepare_nmap_table();

	$zzz{'nessus-table'} = $nessus_table;

	&zzz_whisker_table();

	$zzz{'was-nmap'} = 1;
	$zzz{'was-nessus'} = 1;
	$zzz{'was-whisker'} = $was_whisker;
	$zzz{'was-whiskers'} = $was_whiskers;

	$zzz{'test-from-ip'} = $test_from_ip;
} # zzz_prepare


# projede radek a nahradi vyskyty ZZZ-promene
# za hodnotu $zzz{promene} (pokud neexistuje tak za XXX)
sub zzz_expand() {
	if(@_[0] =~ /ZZZ-([-a-z]*)/)  {
		$var = $1;

		$val = $zzz{$var};

		if( not $val ) {
			$val = "XXX-$var";
		}
		
		@_[0] =~ s/ZZZ-([-a-z]*)/$val/e;
		return 1;
	}
	return 0;
}

sub html_save() {

	my $r;

	my $want_print = 1;
	my @ifstack;
	my $var = "top-level";

	print "saving $hi_file.main.html\n";

	open(HTML, ">$hi_file.main.html");
	open(TEMPLATE, "hi-template.html");

	while($r = <TEMPLATE>) {

		if( $r =~ /^<!--if-([-a-z]+)-->/ ) {
			my $vvar = $1;

			push(@ifstack, $want_print, $var);

			$var =  $vvar;
			$want_print = $zzz{$var};

		} elsif( $r =~ /^<!--else-([-a-z]+)-->/ ) {
			
			if($var ne $1 ) {
				$r .= "found else-$1 but else-$var expected";
			}

			$want_print = not $want_print;

		} elsif( $r =~ /^<!--fi-([-a-z]+)-->/ ) {
			if($var ne $1 ) {
				$r .= "found else-$1 but else-$var expected";
			}
			$var = pop(@ifstack);
			$want_print = pop(@ifstack);
		} elsif(not $want_print) {
			next;
		}

		while( &zzz_expand($r)){};
		print HTML $r;
	}
		
	close HTML;
	close TEMPLATE;
} #html_log_save

sub htmllog_cls(){
	my ($sec, $title) = @_;;

	$htmllog_sec =  $sec;
	$htmllog{"$sec"} = "$title";

} #htmllog_cls

sub htmllog_msg(){
	my ($msg) = @_;
	$htmllog{"$htmllog_sec"} .= "$msg";
} #html

############################################################################
# uniq(@sorted_arr) -- vrati pole bez redundanci
# 
# 

sub uniq() {
	my @arg = @_;;
	my @ret;
	my $cur;


	if( 0 == @arg ) {
		return ();
	}

	push(@ret, $last = shift(@arg));

	while(@arg) {
		$cur = shift(@arg);
		if( $cur ne $last) {
			push(@ret, $cur);
			$last = $cur;
		}
	}
	return @ret;
} #uniq
	

############################################################################
# is_in(elm, @arr)
# 
# 

sub is_in() {
	my $elem = shift(@_);
	my @arr = @_;
	my $i;

	foreach$i(@arr) {
		if($i eq $elem) {
			return 1;
		}
	}
	return 0;
} #is_in


############################################################################
# usage
# 


($load_ports, $do_ipchains);

sub usage() {
	print
"usage: hi.pl [--host|-h HOST| --ip|-i IP] [-pPORTSPEC]
        -h HOST
        -i IP
	-p PORTSPEC passed to nmap -sS [1-]
	-P PORTSPEC passed to nmap -sU [1-200]

	-r|--request testyp;date;email;from outside info

	--fake testyp;date;email;from outside info

	-g|--ping ping
	-d|--dns run dns test
	-w|--whois run whois
	-W|--whisker run whois
	-n|--nmap run nmap
	-N|--nessus run nesssus
	(if non of them is given, run all tests)
	-x skip all tests (for debuging)
		
	-f|--not-fw don't do ipchains optimalization
	-l|--load-ports load opened ports from hi-ip-open-ports before nessus

	-H|--help this help
";
	
} # usage


($do_dns, $do_whois, $do_whisker, $do_nmap,
$do_whisker, $do_nessus, $do_ping, $do_nothing);

############################################################################
# parseopt
# 

sub parseopt() {

	$do_ipchains = 1;

	my @args = @ARGV;

	while(@args) {
		my $op = shift(@args);
		
		if( $op =~ /-h|--host/ ) {
			(not $host_ip ) or die "--ip XOR --host";
			$host_name = shift(@args);

		}elsif( $op =~ /-i|--ip/ ) {
			$host_ip = shift(@args);

			(not $host_name ) or die "--ip XOR --host";

			if($host_ip !~ /^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$/) {
				die "bad ip format: $host_ip";
			}
		}elsif( $op =~ /^--fake/ ) {
			$do_fake = 1;
		}elsif( $op =~ /^-r|^--request/ ) {
			($zzz{'test-type'},
			 $zzz{'request-date'},
			 $zzz{'request-email'},
			 $zzz{'request-from'}) = split(';', shift(@args), 4);
			
		}elsif( $op =~ /^-p/ ) {
			$nmap_ports = shift(@args);
		}elsif( $op =~ /^-P/ ) {
			$nmap_ports2 = shift(@args);
		}elsif( $op =~ /^-g|^--ping/ ) {
			$do_ping = 1;
		}elsif( $op =~ /^-d|^--dns/ ) {
			$do_dns = 1;
		}elsif( $op =~ /^-w|^--whois/ ) {
			$do_whois = 1;
		}elsif( $op =~ /^-W|^--whisker/ ) {
			$do_whisker = 1;
		}elsif( $op =~ /^-n|^--nmap/ ) {
			$do_nmap = 1;
		}elsif( $op =~ /^-l|^--load-ports/ ) {
			$load_ports = 1;
		}elsif( $op =~ /^-N|^--nessus/ ) {
			$do_nessus = 1;
		}elsif( $op =~ /^-f|^--not-fw/ ) {
			$do_ipchains = 0;
		}elsif( $op =~ /^--test/ ) {
			$test_sth = 1;
		}elsif( $op =~ /^-x/ ) {
			$do_nothing = 1;
		}elsif( $op =~ /^-H|^--help/ ) {
			&usage(); 
			die;
		}else{
			print "unknown arg: $op\n";
			&usage(); 
			die;
		}

		
	}

	if( not ($do_dns ||  $do_whois || $do_whisker || $do_nmap ||
		$do_whisker || $do_nessus || $do_ping || $do_nothing) ) {
		
		$do_dns = $do_whois = $do_whisker =  $do_ping =
		$do_nmap = $do_whisker = $do_nessus = 1;
	}
	$host_name_or_ip = $host_ip if($host_ip);
	$host_name_or_ip = $host_name if($host_name);
}
#parseopt


sub host_to_ip() {
	my ($name) = @_;;
	($name, $alias, $addrtype, $addrlen, $iaddr) = gethostbyname($name)
		or die "cannt find [$name] in dns";
	return inet_ntoa($iaddr);
}


############################################################################
# test_dns (ip)
#
# zjisti z ip jeho domain name a pak zpet. tyto vysledky porovna. 

sub parse_dig(){
	my ($cmd, $id) = @_;;
	my %ret;
	@{$ret{"ans"}} = ();
	@{$ret{"aut"}} = ();
	@{$ret{"add"}} = ();

	my $sec;

	&log_sec("\$ $cmd\n", "$id");

	open(F, "$cmd|") or die "cann exe \$ $cmd";
	while($r = <F>) {
		&log_msg($r);
		chomp($r);
		$sec = "aut" if($r =~ /^;; AUTHORITY SECTION:/);
		$sec = "ans" if($r =~ /^;; ANSWER SECTION:/);
		$sec = "add" if($r =~ /^;; ADDITIONAL SECTION:/);
		next if( $r =~ /^;/);
		next if( $r =~ /^\s*$/);
		push(@{$ret{$sec}}, $r);
	}
	close(F);
	return (
		join(";", @{$ret{"ans"}}),
		join(";", @{$ret{"aut"}}),
		join(";", @{$ret{"add"}}));
}
#parse_dig()

sub cut_section() {
	my ($ans) = @_;;
	my @ret = ();
	my $i;
	foreach$i(split /;/, $ans) {
		my @one = split /\s+/, $i;
		$one[4] =~ s/\.$//;
		push(@ret, $one[4]);
	}
	return @ret;
} # cut_section

############################################################################
# test_nserv (ip, nserv, hostname...)
#
# otestuje jesti ns `nserv' zna `hostname' take pod ip `ip'
#

sub  test_nserv() {
	my $ip = shift(@_);
	my $ns = shift(@_);
	my @hosts = @_;
	my $h;


	foreach$h(@hosts) {
		my ($ans, $aut, $add) = &parse_dig("dig \@$ns $h", $ns);
		my @anss = &cut_section($ans);
		if( ! &is_in($ip, @anss )) {
			&war( "DNS: Nameserver $ns nezn $h ".
				"pod IP $ip. Zn ho jako ".
				join(", ",@anss) .
				&ahref("#$ns", "log"));
		}
	}

} #test_nserv 


sub test_dns() {
	my ($ip) = @_;;

	&log_open("dns");
	&htmllog_cls("dns", "<h2>dns</h2>");

 	my ($ans, $aut, $add) = &parse_dig("dig -x $ip", "rev");

	my @anss = &cut_section($ans);
	my @rev_nservs = &cut_section($aut);
	my $ns;

	@host_names = @anss;

	if(@anss == 0) {
		&war( "DNS: Nen, dn reverzn zznam pro $ip".
			&ahref("#rev", "log"));
		return;
	}
	if(@anss > 1) {
		&war( "DNS: vce reverznch zznam pro jednu IP".
			"(beru pouze $anss[1] ".
			&href("$log_name#rev", "log"));
	}
	my $hn = $anss[0];
	
	print "host_name:$host_name hn: $hn\n";

	if( $host_name && ($host_name ne $hn) ) {
		&war( "DNS: Zadany host ($host_name) m IP ($ip) ".
			" odpovdajc jinmu jmnu ($hn)".
			&ahref("#rev", "log"));
	}

	$host_name = $hn;

	print("dns:host_name: $host_name\n");

 	($ans, $aut, $add) = &parse_dig("dig $host_name", "ip");

	@host_ips = &cut_section($ans);
	@host_nservers = &cut_section($aut);

	print "nservs: ", join(",", @host_nservers ), "\n";
	print "ips: ", join(",", @host_ips ), "\n";

	foreach$ns(@host_nservers){
		&test_nserv($host_ip, $ns, @anss);
	}

	&log_close();

} #test_dns

#################################################################
# test whois
#

(@whois_basic);
(@whois_more);

# who_is_cmd(server, query)
sub whois_cmd() {
	my ($server, $query) = @_;;
	if( $whois_is_gnu ) {
		return "whois -h $server -- '$query'";
	}else {
		return "whois '$query\@$server'";
	}
} # whois_cmd

sub whois_get() {
	my ($server, $query, $id) = @_;;
	my $cmd = &whois_cmd($server, $query);

	my @ret;

	&log_sec("\$ $cmd\n", $id);
	open(F, "$cmd|") or die "cannt exe \$ $cmd\n";

	my $i = 0 , $is_non_empty = 0;

	while($r = <F>) {
		&log_msg($r);
		chomp($r);
		if( $r =~ /^%/ ) { next; }

		if( $r =~ /^\s*$/ ) {
			if( $is_non_empty )  {
				$i++;
				#is_non_empty = 0;
			}
			next
		}

		if( $r =~ /^([-a-z]+):\s*(.*)/ ) {
			my $attr = $1;
			my $val = $2;
			$is_non_empty = 1;
			push(@{$ret[$i]}, "$attr: $val");
			next;
		}
		# what? nonsense, here nothing

	}
	close(F);
	return @ret;
	
} #whois_get

# whois_find_attr -> (vaules)
sub whois_find_attr()
{
	my $attr = shift(@_);
	my @args = @_;;
	my $i, $j;
	my @ret;

	foreach$i(@args) {
		foreach$j(@{$i}) {
			my ($a, $val) = split(':\s*', $j, 2);
			if( $a eq $attr) {
				push(@ret, $val);
			}
		}
	}
	return @ret;
} #whois_find_attr
	
sub whois_ask_person() {
	my @per = @_;;
	my $i, $j, $k;
	my @zam = qw(domain:adminc domain:techc domain:billc 
		role:adminc role:techc role:billc);
	my @ret;

	&war("<p>Prohledavani osob:<ul>");
	foreach$i(@per) {
		&war(" <li> Osoba $i: <ul>");
		foreach $j(@zam) {
			my $id = "nic-$i-$j";
			my @ans = &whois_get("whois.nic.cz", "-s $j $i", $id);
			my $anslen =  @ans;
			&war("   <li> $j: $anslen ($ans[0][0]) ".
				&ahref("#$id", "log"));
			push(@ret, @ans);
		}
		&war("</ul>");
	}
	&war("</ul>");

	return @ret;
} # whois_ask_person

# whois_ask_nservers(nservers) --> zepta se nic.cz na tyto nservery
sub whois_ask_nservers() {
	my @ser = @_;;
	my $i, $j, $k;
	my @ret;

	&war("<p>Nameservery:<ul>");
	foreach$i(@ser) {
		my $id = "nserver-$i";
		my @ans = &whois_get("whois.nic.cz",
			"-s domain:nserver $i", $id);
		my $anslen = @ans;
		&war("  <li> $i : $anslen ($ans[0][0])".
			&ahref("#$id", "log"));
		push(@ret, @ans);
	}
	&war("</ul>");

	return @ret;

} # whois_ask_nservers


# otestuje jestli whoisem nalezene servery jsou i ns dle digu
# whois_test_nservers(whoisem_nalezene_servery)

sub whois_test_nservers() {
	
	my @wi_ser = @_;;
	my $i;
	my @not_in;
	
	foreach$i(@wi_ser) {
		if( not &is_in($i, @host_nservers)) {
			&war("<p>DNS: $i is DNS server according ".
				" whois.ripe.net, however it isn't.");
			push(@not_in, $i);
		}
	}
	push(@host_nservers, @not_in);
} # whois_test_nservers
	
	

sub whois_test() {

	&log_open("whois");
	&htmllog_cls("whois", "<h2>whois</h2>");

	print "whois\n";

	@ripe = &whois_get("whois.ripe.net", $host_ip);

	my @desc = &whois_find_attr("descr", @ripe);

	$host_ip_owner = join ',', @desc;

	print "  host_ip_owner: $host_ip_owner\n";

	if(not $host_name) {
		return;
	}

	if( $host_name =~ /\.([-_a-zA-Z0-9]+\.[-_a-zA-Z0-9]+)$/) {
		$second_level_domain = $1;
	} else {
		die "host name nema sec level domain($host_name) ".
			"(or bad regexp)";
	}
		
	
	@ripe = &whois_get("whois.nic.cz",
			"-s domain:name $second_level_domain");
	my @desc = &whois_find_attr("descr", @ripe);

	$second_level_domain_owner = join ',', @desc;

	print "  second_level_domain: $second_level_domain\n";
	print "  second_level_domain_owner: $second_level_domain_owner\n";

} # whois_test

sub whois_test_old() {
	my @ripe;
	
	&log_open("whois");
	&htmllog_cls("whois", "<h2>whois</h2>");

	@ripe = &whois_get("whois.ripe.net", $host_ip);

	my @adminc = &whois_find_attr("admin-c", @ripe);
	my @techc = &whois_find_attr("tech-c", @ripe);
	my @billc = &whois_find_attr("bill-c", @ripe);
	my @nserver = &whois_find_attr("nserver", @ripe);

	print "admin-c:", join(", ", @adminc), "\n";
	print "tech-c:", join(", ", @techc), "\n";
	print "bill-c:", join(", ", @billc), "\n";
	print "nserver:", join(", ", @nserver), "\n";

	my @per = &uniq(sort @adminc, @techc, @billc);
	print "presons:",  join(", ", @per), "\n";

	&whois_ask_person(@per);

	&whois_test_nservers(@nserver);
	&whois_ask_nservers(@host_nservers);

	&log_close();

} #whois_test

#################################################################
# nmap test
#

# parse_nmap_log(file) --> %($rest, @open, @closed, @filtered) 
# v @{$ret{"open+"}} je port podrobneji rozepsan ve fromatu:
# 21/tcp;open;ftp
# rest je bud open, closed, filtered. ostatni jsou seznamy
sub parse_nmap_log() {

	my ($file) = @_;;
	open(NL, $file) or die "cannt open $file";

	my %ret;
	my $in_table = 0;

	$r = <NL>;

	if( $r =~ /# nmap \(V.([^\)]*)\)/ ) {
		$nmap_version = "nmap $1";
	}
		
	
	while($r = <NL>) {
		chomp($r);

		$r =~ s/#.*$//;
		if( $r =~ /^\s*$/ ) {
			$in_table = 0;
			next;
		}
		if( $r =~ /\(The (\d+ |)ports? scanned but not shown below are in state: (\S+)\)$/  ) {
			my $rest = $2;
			$ret{"rest"} = $2;
			next;
                }
		if( $r =~ 
			/^Port       State       Service$/ ) {
			$in_table = 1;
			next;
		}
		if ($r =~ /^Remote operating system guess:(.*)$/ ) {
			$ret{"os"} = $1;
			next;
		}
		if ($r =~ /^No exact OS matches for host/ ) {
			$ret{"os"} = "Nepodailo se zjistit";
			next;
		}
		if( ! $in_table ) {
			next;
		}

		if( ($r =~ /^(\S+)\/(\S+)\s+(\S+)\s+(\S+)/ ) ) {
			my ($port, $proto, $state, $name) = ($1, $2, $3, $4);
			push(@{$ret{"$state+"}}, "$port($name)");
			#push(@{$ret{"$state+"}}, "$port;$proto;$state;$name");
			push(@{$ret{"$state"}}, "$port");
			next;
		}
	}
	return %ret;
} # parse_nmap_log 

# nmap_doit(file, port, scan)
sub nmap_doit(){
	
	my ($file, $ports, $scan) = @_;;
	my $cmd = "nmap  $host_ip $ports -s$scan -oN $file -P0";
	my $r;

	$cmd = "echo nmap" if ($do_fake);

	#&log_sec("\$ $cmd\n", $scan);
	#open(F,  "$cmd|") or die "cannt exe \$ $cmd\n";
	#while($r = <F>) { &log_msg($r) };

	&my_system("$cmd", "nmap-$scan");

	return &parse_nmap_log($file);
	
} # nmap_doit

#sub nmap_has_port(port, @vysedna table) 
sub nmap_has_port() {
	my $search_for_port  = shift(@_);;
	my @arr = @_;;

	return &is_in($search_for_port, @arr);
} # nmap_has_port

sub nmap_has_http() {
	return 1 if($do_fake);
	return &nmap_has_port(80, @{$host_ports_tcp{"open"}});
}# nmap_has_http

sub nmap_has_https() {
	return 1 if($do_fake);
	return &nmap_has_port(443, @{$host_ports_tcp{"open"}});
}# nmap_has_http

# nmap_print(txt, list)
sub nmap_print(){

	my $txt = shift(@_);
	my @arr = @_;;
	my $i;
	
	if(!@arr)  {
		return;
	}

	&war($txt);
	foreach$i(@arr){
		my ($port, $proto, $state, $name) = split(';', $i);
		&war("<li> $port($name)");
	}

}

sub mnap_save_open_ports() {

	my $fn = "$hi_file-ports-open";
	open(FPORT, ">$fn") or die "cannt write to $fn" ;
	print FPORT join(",", @{$host_ports_tcp{"open"}}), "\n";
	close(FPORT);
	
} # mnap_save_open_ports

sub nmap_load_open_ports() {

	my $fn = "$hi_file-ports-open";

	open(FPORT, "$fn") or die "cannt open $fn";
	my $r = <FPORT>;
	chomp($r);
	my @rr = split ",", $r;
	push(@{$host_ports_tcp{"open"}}, @rr);
	print"# loaded ports: ",join(",", @{$host_ports_tcp{"open"}}),"\n";
	close(FPORT);
	
} # mnap_load_open_ports

sub nmap_test() {

	&log_open("nmap");

	%host_ports_tcp =
		&nmap_doit("$hi_file-nmap-s", "-O -p $nmap_ports", "S");

	&war("Tcp porty:\n");
	&nmap_print("Otevrene:\n", @{$host_ports_tcp{"open+"}});
	&nmap_print("Zavrene:\n", @{$host_ports_tcp{"closed+"}});
	&nmap_print("Filtrovane:\n", @{$host_ports_tcp{"filtered+"}});

	$host_os = $host_ports_tcp{"os"};

	my $rest = $host_ports_tcp{"rest"};
	my $rest_txt =
		($rest eq "open")? "otevrene":
		($rest eq "closed")? "uzavrene":
		($rest eq "filtered")? "filtered":
		($rest eq "")?"zadne":"divne";

	&war("Ostatni jsou $rest_txt");

	&war("Udp porty:\n");

	%host_ports_udp =
		&nmap_doit("$hi_file-nmap-u", "-p %$nmap_ports2", "U");
	&nmap_print("Otevrene:\n", @{$host_ports_udp{"open+"}});
	&nmap_print("Zavrene:\n", @{$host_ports_udp{"closed+"}});
	&nmap_print("Filtrovane:\n", @{$host_ports_udp{"filtered+"}});


	my $rest = $host_ports_udp{"rest"};
	my $rest_txt =
		($rest eq "open")? "otevrene":
		($rest eq "closed")? "uzavrene":
		($rest eq "filtered")? "filtered":
		($rest eq "")?"zadne":"divne";

	&war("Ostatni jsou $rest_txt.");
	
	&mnap_save_open_ports();

	&log_close();

} # nmap_test() 

#################################################################
# whisker_test
#
sub parse_whisker() {
	my ($filename) = @_;;

	my %ret;
	open(WHISKER, "$filename") or die "cannt open $filename";

	my ($server, $plus, $minus);
	while($r = <WHISKER> ) {
		chomp$r;
		if( $r =~ /^= Server: (.*)$/ ) {
			$ret{"server"} = "$1";
			next;
		}
		if($r =~ /^- (.*)$/) {
			$ret{"note"} .= "$1\n";
			next;
		}
		if($r =~ /^\+ (.*)$/) {
			$ret{"report"} .= "$1\n";
			next;
		}
	}

	close(WHISKER);

	return %ret;

} # parse_whisker


sub whisker_test() {
	&log_open("whisker");

	my $filename = "$hi_file-whisker.log";

	if( not &nmap_has_http() ) {

		print "no port 80, no whisker http\n";
		return;
	}

	if($do_fake) {
		&my_system("cat whisker-ufdr.log| tee $filename");
	} else {
		&my_system("cat whisker-ufdr.log| tee $filename");
	}

	%whisker_http = &parse_whisker("$filename");

	$was_whisker = 1;
} # whisker_test

sub whiskers_test() {
	&log_open("whiskers");

	my $filename = "$hi_file-whiskers.log";

	if( not &nmap_has_https() ) {

		print "no port 8080, no whisker http\n";
		return;
	}

	if($do_fake) {
		&my_system("cat whiskers-ufdr.log| tee $filename");
	} else {
		&my_system("cat whiskers-ufdr.log| tee $filename");
	}

	%whisker_https = &parse_whisker("$filename");

	$was_whiskers = 1;
} # whiskers_test


#################################################################
# nesssus_test
#

# odfiltruje vsechny porty k danemu ip krome otevrenych. 
sub nessus_ipchains_close(){
	
	my $port;

	&my_system("echo ipchains -F output");

	foreach$port(@{$host_ports_tcp{"open"}}){
		&my_system("echo ipchains -F output -p tcp ".
			" -d $host_ip $port -j ACCEPT");
	}

	&my_system("echo ipchains -F output -p tcp -d $host_ip -j REJECT");

} # nessus_ipchains_close

# odnastavi blbosti.

sub nessus_ipchains_open(){
	&my_system("echo ipchains -F output");
} # &nessus_ipchains_close

sub parse_nessus() {
	my ($filename) = @_;;


	&war("nessus -- brief\n");

	my $last_port = "";
	my %count;

	open(NESSUS, "$filename") or die "cannt open $filename";
	while($r = <NESSUS> ) {

		my ($ip, $port, $id, $typ, $txt) = split('\|', $r, 5);

		if( not $txt ) {
			next;
		}

		$count{$typ}++;

		if( $last_port ne $port ) {
			$nessus_table .= ###out
"<tr>
   <td bgcolor=\"#C0C0C0\" colspan=\"2\" nowrap><strong>$port</strong></td>
</tr>";
		}

		my $color = ###out
			$typ eq "INFO" ? "AAF997":
			$typ eq "NOTE" ? "FBD795":
			$typ eq "REPORT" ? "F48A8A" : "FFFFF";

		$txt =~ s/;/<br>\n    /g; ###out

		$nessus_table .= ###out
"<tr>
  <td valign=\"top\" bgcolor=\"$color\" nowrap>
    <strong>$typ</strong></td>
  <td valign=\"top\" nowrap>
    $txt
  </td>
</tr>

";
		$last_port = $port;

	}

	$nessus_info_count = $count{'INFO'};
	$nessus_note_count = $count{'NOTE'};
	$nessus_report_count = $count{'REPORT'};

	if( 0 == $nessus_info_count +
		$nessus_note_count +
		$nessus_report_count ) {
		$nessus_table = ###out
			"<tr><td>dn maliny</td></tr>\n";
	}
	close(NESSUS);
}
sub find_nessus_version() {

	open(NESSVER, "nessus --version|");
	my $r = <NESSVER>;
	close(NESSVER);

	$nessus_version = "$r (databze z JAK-TO-MAM-JAKO-ZJISTIT?)";

} #find_nessus_version 

sub nessus_test() {

	&log_open("nessus");

	my $filename = "$hi_file-nessus.log";

	if($do_ipchains) {
		&nessus_ipchains_close();
	} else {
		print "# `-- ipchains skiped\n";
	}

	&my_system("cat nessus-test.nsr > $filename", "nessus");

	&parse_nessus("$filename");
	&find_nessus_version();

	if($do_ipchains) {
		&nessus_ipchains_open();
	}

	&log_close();
} # nessus_test() 

sub ping_test() {

	my $ret;

	$ret = system("ping -c1 $host_ip");
	
	if($ret) {
		$icmp_ping = "nepinga";
	} else {
		$icmp_ping = "pinga";
	}
	
} # d

#bug: my_ip == ip of eth0 @^;;
sub my_ip() {

	my $my_ip;
	open(MYIP, "/sbin/ifconfig eth0|") or die "cannt run ifconfig";
	while($r=<MYIP>) {
		if($r =~  /inet addr:(\S*)/ ) {
			$my_ip = $1;
		}
	}
	close(MYIP);
			
	print "my_ip: $my_ip\n";
	$test_from_ip = $my_ip;
} # my_ip

#################################################################
# main
#


&parseopt();


if ($host_name) {
	( not $host_ip ) or die "--ip XOR --host is required";
	$host_ip = &host_to_ip($host_name);
}

if( $test_sth ) {
	&html_save();
	die "test die";
}

#open(LOG_FILE, ">hi.log") or die "cannt open hi.log";

print "# ", join(" ", @ARGV), "\n";
print "# ip: $host_ip\n";

$hi_file = "hi-$host_ip";

&htmllog_load();

$test_begin = &date();

if($do_dns) {
	print "# dns\n";
	&test_dns($host_ip);
} else {
	print "# dns skiped\n";
}

if($do_whois) {
	print "# whois\n";
	&whois_test();
} else {
	print "# whois skiped\n";
}

if($do_ping) {
	print "# ping  ";
	&ping_test();
} else {
	print "# ping skiped\n";
}

if($do_nmap) {
	print "# nmap  ";
	&nmap_test();
} else {
	print "# nmap skiped\n";
}

if($load_ports && $do_nmap) {
	print "warinig: i did nmap, but now loading ports from file\n"
}

if($load_ports) {
	&nmap_load_open_ports();
}

if($do_whisker) {
	print "# whisker\n";
	&whisker_test();

	print "# whiskers\n";
	&whiskers_test();
} else {
	print "# whisker skiped\n";
}

if($do_nessus) {
	print "# nessus\n";
	&nessus_test();
} else {
	print "# nessus skiped\n";
}

$test_end = &date();
&my_ip();

print "# saving main log\n";
&zzz_prepare();
&html_save();
&zzz_print();



#foreach$k(keys %whisker_https){
#	print "whisker_https{$k}=$whisker_https{$k}\n";
#}
#print "beg: $htmllog{beging}\n"

# struktura 
# html
# hi-ip.html
# hi-ip-TEST-log.html TEST {dns,whois,nmap,whisker,nessus}
# sekce bude uvozna: <!--test:TEST--> posledni je end.

#todo: dns : pri zadani host_name lepsi detekce ze je spatna ip.
# nmap -O
# parse arg: multiop like -xzrmfs
